org.apache.activemq.artemis.api.core.management

## Interface ActiveMQServerControl

-     public interface ActiveMQServerControl

  An ActiveMQServerControl is used to manage ActiveMQ Artemis servers.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addAddressSettings(String addressMatch, String DLA, String expiryAddress, long expiryDelay, boolean lastValueQueue, int deliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageMaxCacheSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics)` adds a new address setting for a specific address
    `void` | `addSecuritySettings(String addressMatch, String sendRoles, String consumeRoles, String createDurableQueueRoles, String deleteDurableQueueRoles, String createNonDurableQueueRoles, String deleteNonDurableQueueRoles, String manageRoles)`
    `void` | `addSecuritySettings(String addressMatch, String sendRoles, String consumeRoles, String createDurableQueueRoles, String deleteDurableQueueRoles, String createNonDurableQueueRoles, String deleteNonDurableQueueRoles, String manageRoles, String browseRoles)`
    `boolean` | `closeConnectionsForAddress(String ipAddress)` Closes all the connections of clients connected to this server which matches the specified IP address.
    `boolean` | `closeConnectionsForUser(String address)` Closes all the connections of sessions with a matching user name.
    `boolean` | `closeConsumerConnectionsForAddress(String address)` Closes all the connections of clients connected to this server which matches the specified IP address.
    `boolean` | `commitPreparedTransaction(String transactionAsBase64)` Heuristically commits a prepared transaction.
    `void` | `createBridge(String name, String queueName, String forwardingAddress, String filterString, String transformerClassName, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, int producerWindowSize, long clientFailureCheckPeriod, String connectorNames, boolean useDiscoveryGroup, boolean ha, String user, String password)`
    `void` | `createBridge(String name, String queueName, String forwardingAddress, String filterString, String transformerClassName, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, long clientFailureCheckPeriod, String connectorNames, boolean useDiscoveryGroup, boolean ha, String user, String password)`
    `void` | `createConnectorService(String name, String factoryClass, Map<String,Object> parameters)`
    `void` | `createDivert(String name, String routingName, String address, String forwardingAddress, boolean exclusive, String filterString, String transformerClassName)`
    `void` | `createQueue(String address, String name)` Create a durable queue.
    `void` | `createQueue(String address, String name, boolean durable)` Create a queue.
    `void` | `createQueue(String address, String name, String filter, boolean durable)` Create a queue.
    `void` | `deployQueue(String address, String name, String filter)` Deploy a durable queue.
    `void` | `deployQueue(String address, String name, String filter, boolean durable)` Deploy a queue.
    `void` | `destroyBridge(String name)`
    `void` | `destroyConnectorService(String name)`
    `void` | `destroyDivert(String name)`
    `void` | `destroyQueue(String name)` Destroys the queue corresponding to the specified name.
    `void` | `destroyQueue(String name, boolean removeConsumers)` Destroys the queue corresponding to the specified name.
    `void` | `disableMessageCounters()` Disables message counters for this server.
    `void` | `enableMessageCounters()` Enables message counters for this server.
    `void` | `forceFailover()`
    `String[]` | `getAddressNames()` Returns the addresses created on this server.
    `String` | `getAddressSettingsAsJSON(String addressMatch)` returns the address settings as a JSON string
    `String` | `getBindingsDirectory()` Returns the file system directory used to store bindings.
    `String[]` | `getBridgeNames()`
    `int` | `getConnectionCount()` Returns the number of clients connected to this server.
    `long` | `getConnectionTTLOverride()` Returns the connection time to live.
    `Object[]` | `getConnectors()` Returns the connectors configured for this server.
    `String` | `getConnectorsAsJSON()` Returns the connectors configured for this server using JSON serialization.
    `String[]` | `getConnectorServices()`
    `int` | `getDiskScanPeriod()` Returns how often the server checks for disk space usage.
    `String[]` | `getDivertNames()`
    `long` | `getGlobalMaxSize()` Returns the global max bytes limit for in-memory messages.
    `int` | `getIDCacheSize()` Returns the size of the cache for pre-creating message IDs.
    `String[]` | `getIncomingInterceptorClassNames()` Returns the list of interceptors used by this server for incoming messages.
    `int` | `getJournalBufferSize()` Returns the size of the internal buffer on the journal.
    `int` | `getJournalBufferTimeout()` Returns the timeout (in nanoseconds) used to flush internal buffers on the journal.
    `int` | `getJournalCompactMinFiles()` Returns the minimal number of journal files before compacting.
    `int` | `getJournalCompactPercentage()` Return the percentage of live data before compacting the journal.
    `String` | `getJournalDirectory()` Returns the file system directory used to store journal log.
    `int` | `getJournalFileSize()` Returns the size (in bytes) of each journal files.
    `int` | `getJournalMaxIO()` Returns the maximum number of write requests that can be in the AIO queue at any given time.
    `int` | `getJournalMinFiles()` Returns the number of journal files to pre-create.
    `String` | `getJournalType()` Returns the type of journal used by this server (either `NIO` or `ASYNCIO`).
    `String` | `getLargeMessagesDirectory()` Returns the file system directory used to store large messages.
    `String` | `getManagementAddress()` Returns the management address of this server.
    `String` | `getManagementNotificationAddress()` Returns the management notification address of this server.
    `int` | `getMaxDiskUsage()` Returns the disk use max limit.
    `int` | `getMessageCounterMaxDayCount()` Returns the maximum number of days kept in memory for message counter.
    `long` | `getMessageCounterSamplePeriod()` Returns the sample period (in milliseconds) to take message counter snapshot.
    `long` | `getMessageExpiryScanPeriod()` Returns the frequency (in milliseconds) to scan messages to detect which messages have expired.
    `long` | `getMessageExpiryThreadPriority()` Returns the priority of the thread used to scan message expiration.
    `String[]` | `getOutgoingInterceptorClassNames()` Returns the list of interceptors used by this server for outgoing messages.
    `String` | `getPagingDirectory()` Returns the file system directory used to store paging files.
    `String[]` | `getQueueNames()` Returns the names of the queues created on this server.
    `Object[]` | `getRoles(String addressMatch)`
    `String` | `getRolesAsJSON(String addressMatch)`
    `int` | `getScheduledThreadPoolMaxSize()` Returns the maximum number of threads in the scheduled thread pool.
    `long` | `getSecurityInvalidationInterval()` Returns the interval time (in milliseconds) to invalidate security credentials.
    `int` | `getThreadPoolMaxSize()` Returns the maximum number of threads in the thread pool.
    `long` | `getTotalConnectionCount()` Returns the number of clients which have connected to this server since it was started.
    `long` | `getTotalConsumerCount()` Returns the number of messages sent to this server since it was started.
    `long` | `getTotalMessageCount()` Returns the number of messages in all queues on the server.
    `long` | `getTotalMessagesAcknowledged()` Returns the number of messages sent to this server since it was started.
    `long` | `getTotalMessagesAdded()` Returns the number of messages sent to this server since it was started.
    `long` | `getTransactionTimeout()` Returns the timeout (in milliseconds) after which transactions is removed from the resource manager after it was created.
    `long` | `getTransactionTimeoutScanPeriod()` Returns the frequency (in milliseconds) to scan transactions to detect which transactions have timed out.
    `String` | `getUptime()` Returns the uptime of this server.
    `long` | `getUptimeMillis()` Returns the uptime of this server.
    `String` | `getVersion()` Returns this server's version.
    `boolean` | `isAsyncConnectionExecutionEnabled()` Returns whether code coming from connection is executed asynchronously or not.
    `boolean` | `isBackup()` Returns `true` if this server is a backup, `false` if it is a live server.
    `boolean` | `isClustered()` Returns whether this server is clustered.
    `boolean` | `isCreateBindingsDir()` Returns whether the bindings directory is created on this server startup.
    `boolean` | `isCreateJournalDir()` Returns whether the journal directory is created on this server startup.
    `boolean` | `isFailoverOnServerShutdown()` returns if clients failover on a server shutdown
    `boolean` | `isJournalSyncNonTransactional()` Returns whether the journal is synchronized when receiving non-transactional data.
    `boolean` | `isJournalSyncTransactional()` Returns whether the journal is synchronized when receiving transactional data.
    `boolean` | `isMessageCounterEnabled()` Returns whether message counter is enabled for this server.
    `boolean` | `isPersistDeliveryCountBeforeDelivery()` Returns whether delivery count is persisted before messages are delivered to the consumers.
    `boolean` | `isPersistenceEnabled()` Returns whether this server is using persistence and store data.
    `boolean` | `isPersistIDCache()` Returns whether message ID cache is persisted.
    `boolean` | `isReplicaSync()` Returns whether the initial replication synchronization process with the backup server is complete; applicable for either the live or backup server.
    `boolean` | `isSecurityEnabled()` Returns whether security is enabled for this server.
    `boolean` | `isSharedStore()` Returns whether this server shares its data store with a corresponding live or backup server.
    `boolean` | `isStarted()` Return whether this server is started.
    `boolean` | `isWildcardRoutingEnabled()` Returns whether wildcard routing is supported by this server.
    `String` | `listAllConsumersAsJSON()` Lists all the consumers connected to this server.
    `String[]` | `listConnectionIDs()` Lists all the IDs of the connections connected to this server.
    `String` | `listConnectionsAsJSON()` Lists all the connections connected to this server.
    `String` | `listConsumersAsJSON(String connectionID)` Lists all the consumers which belongs to the connection specified by the connectionID.
    `String[]` | `listHeuristicCommittedTransactions()` List transactions which have been heuristically committed.
    `String[]` | `listHeuristicRolledBackTransactions()` List transactions which have been heuristically rolled back.
    `String` | `listPreparedTransactionDetailsAsHTML()` List all the prepared transaction, sorted by date, oldest first, with details, in HTML format
    `String` | `listPreparedTransactionDetailsAsJSON()` List all the prepared transaction, sorted by date, oldest first, with details, in text format.
    `String[]` | `listPreparedTransactions()` List all the prepared transaction, sorted by date, oldest first.
    `String` | `listProducersInfoAsJSON()`
    `String[]` | `listRemoteAddresses()` Lists the addresses of all the clients connected to this address.
    `String[]` | `listRemoteAddresses(String ipAddress)` Lists the addresses of the clients connected to this address which matches the specified IP address.
    `String[]` | `listSessions(String connectionID)` Lists all the sessions IDs for the specified connection ID.
    `String` | `listSessionsAsJSON(String connectionID)` Lists details about all the sessions for the specified connection ID.
    `void` | `removeAddressSettings(String addressMatch)`
    `void` | `removeSecuritySettings(String addressMatch)`
    `void` | `resetAllMessageCounterHistories()` Reset histories for all message counters.
    `void` | `resetAllMessageCounters()` Reset all message counters.
    `boolean` | `rollbackPreparedTransaction(String transactionAsBase64)` Heuristically rolls back a prepared transaction.
    `void` | `scaleDown(String connector)`
    `void` | `sendQueueInfoToQueue(String queueName, String address)` This method is used by ActiveMQ Artemis clustering and must not be called by ActiveMQ Artemis clients.
    `void` | `setFailoverOnServerShutdown(boolean failoverOnServerShutdown)` do any clients failover on a server shutdown
    `void` | `setMessageCounterMaxDayCount(int count)` Sets the maximum number of days kept in memory for message counter.
    `void` | `setMessageCounterSamplePeriod(long newPeriod)` Sets the sample period to take message counter snapshot.
    `void` | `updateDuplicateIdCache(String address, Object[] ids)`

- - ### Method Detail

    - #### getVersion

          String getVersion()

      Returns this server's version.

    - #### getConnectionCount

          int getConnectionCount()

      Returns the number of clients connected to this server.

    - #### getTotalConnectionCount

          long getTotalConnectionCount()

      Returns the number of clients which have connected to this server since it was started.

    - #### getTotalMessageCount

          long getTotalMessageCount()

      Returns the number of messages in all queues on the server.

    - #### getTotalMessagesAdded

          long getTotalMessagesAdded()

      Returns the number of messages sent to this server since it was started.

    - #### getTotalMessagesAcknowledged

          long getTotalMessagesAcknowledged()

      Returns the number of messages sent to this server since it was started.

    - #### getTotalConsumerCount

          long getTotalConsumerCount()

      Returns the number of messages sent to this server since it was started.

    - #### isStarted

          boolean isStarted()

      Return whether this server is started.

    - #### getIncomingInterceptorClassNames

          String[] getIncomingInterceptorClassNames()

      Returns the list of interceptors used by this server for incoming messages.
      See Also:
        `Interceptor`

    - #### getOutgoingInterceptorClassNames

          String[] getOutgoingInterceptorClassNames()

      Returns the list of interceptors used by this server for outgoing messages.
      See Also:
        `Interceptor`

    - #### isClustered

          boolean isClustered()

      Returns whether this server is clustered.

    - #### getScheduledThreadPoolMaxSize

          int getScheduledThreadPoolMaxSize()

      Returns the maximum number of threads in the scheduled thread pool.

    - #### getThreadPoolMaxSize

          int getThreadPoolMaxSize()

      Returns the maximum number of threads in the thread pool.

    - #### getSecurityInvalidationInterval

          long getSecurityInvalidationInterval()

      Returns the interval time (in milliseconds) to invalidate security credentials.

    - #### isSecurityEnabled

          boolean isSecurityEnabled()

      Returns whether security is enabled for this server.

    - #### getBindingsDirectory

          String getBindingsDirectory()

      Returns the file system directory used to store bindings.

    - #### getJournalDirectory

          String getJournalDirectory()

      Returns the file system directory used to store journal log.

    - #### getJournalType

          String getJournalType()

      Returns the type of journal used by this server (either `NIO` or `ASYNCIO`).

    - #### isJournalSyncTransactional

          boolean isJournalSyncTransactional()

      Returns whether the journal is synchronized when receiving transactional data.

    - #### isJournalSyncNonTransactional

          boolean isJournalSyncNonTransactional()

      Returns whether the journal is synchronized when receiving non-transactional data.

    - #### getJournalFileSize

          int getJournalFileSize()

      Returns the size (in bytes) of each journal files.

    - #### getJournalMinFiles

          int getJournalMinFiles()

      Returns the number of journal files to pre-create.

    - #### getJournalMaxIO

          int getJournalMaxIO()

      Returns the maximum number of write requests that can be in the AIO queue at any given time.

    - #### getJournalBufferSize

          int getJournalBufferSize()

      Returns the size of the internal buffer on the journal.

    - #### getJournalBufferTimeout

          int getJournalBufferTimeout()

      Returns the timeout (in nanoseconds) used to flush internal buffers on the journal.

    - #### setFailoverOnServerShutdown

          void setFailoverOnServerShutdown(boolean failoverOnServerShutdown)
                                    throws Exception

      do any clients failover on a server shutdown
      Throws:
        `Exception`

    - #### isFailoverOnServerShutdown

          boolean isFailoverOnServerShutdown()

      returns if clients failover on a server shutdown

    - #### getJournalCompactMinFiles

          int getJournalCompactMinFiles()

      Returns the minimal number of journal files before compacting.

    - #### getJournalCompactPercentage

          int getJournalCompactPercentage()

      Return the percentage of live data before compacting the journal.

    - #### isPersistenceEnabled

          boolean isPersistenceEnabled()

      Returns whether this server is using persistence and store data.

    - #### isCreateBindingsDir

          boolean isCreateBindingsDir()

      Returns whether the bindings directory is created on this server startup.

    - #### isCreateJournalDir

          boolean isCreateJournalDir()

      Returns whether the journal directory is created on this server startup.

    - #### isMessageCounterEnabled

          boolean isMessageCounterEnabled()

      Returns whether message counter is enabled for this server.

    - #### getMessageCounterMaxDayCount

          int getMessageCounterMaxDayCount()

      Returns the maximum number of days kept in memory for message counter.

    - #### setMessageCounterMaxDayCount

          void setMessageCounterMaxDayCount(int count)
                                     throws Exception

      Sets the maximum number of days kept in memory for message counter.
      Parameters:
        `count` - value must be greater than 0
      Throws:
        `Exception`

    - #### getMessageCounterSamplePeriod

          long getMessageCounterSamplePeriod()

      Returns the sample period (in milliseconds) to take message counter snapshot.

    - #### setMessageCounterSamplePeriod

          void setMessageCounterSamplePeriod(long newPeriod)
                                      throws Exception

      Sets the sample period to take message counter snapshot.
      Parameters:
        `newPeriod` - value must be greater than 1000ms
      Throws:
        `Exception`

    - #### isBackup

          boolean isBackup()

      Returns `true` if this server is a backup, `false` if it is a live server.
      If a backup server has been activated, returns `false`.

    - #### isSharedStore

          boolean isSharedStore()

      Returns whether this server shares its data store with a corresponding live or backup server.

    - #### getPagingDirectory

          String getPagingDirectory()

      Returns the file system directory used to store paging files.

    - #### isPersistDeliveryCountBeforeDelivery

          boolean isPersistDeliveryCountBeforeDelivery()

      Returns whether delivery count is persisted before messages are delivered to the consumers.

    - #### getConnectionTTLOverride

          long getConnectionTTLOverride()

      Returns the connection time to live.
      This value overrides the connection time to live sent by the client.

    - #### getManagementAddress

          String getManagementAddress()

      Returns the management address of this server.
      Clients can send management messages to this address to manage this server.

    - #### getManagementNotificationAddress

          String getManagementNotificationAddress()

      Returns the management notification address of this server.
      Clients can bind queues to this address to receive management notifications emitted by this server.

    - #### getIDCacheSize

          int getIDCacheSize()

      Returns the size of the cache for pre-creating message IDs.

    - #### isPersistIDCache

          boolean isPersistIDCache()

      Returns whether message ID cache is persisted.

    - #### getLargeMessagesDirectory

          String getLargeMessagesDirectory()

      Returns the file system directory used to store large messages.

    - #### isWildcardRoutingEnabled

          boolean isWildcardRoutingEnabled()

      Returns whether wildcard routing is supported by this server.

    - #### getTransactionTimeout

          long getTransactionTimeout()

      Returns the timeout (in milliseconds) after which transactions is removed from the resource manager after it was created.

    - #### getTransactionTimeoutScanPeriod

          long getTransactionTimeoutScanPeriod()

      Returns the frequency (in milliseconds) to scan transactions to detect which transactions have timed out.

    - #### getMessageExpiryScanPeriod

          long getMessageExpiryScanPeriod()

      Returns the frequency (in milliseconds) to scan messages to detect which messages have expired.

    - #### getMessageExpiryThreadPriority

          long getMessageExpiryThreadPriority()

      Returns the priority of the thread used to scan message expiration.

    - #### isAsyncConnectionExecutionEnabled

          boolean isAsyncConnectionExecutionEnabled()

      Returns whether code coming from connection is executed asynchronously or not.

    - #### getConnectors

          Object[] getConnectors()
                          throws Exception

      Returns the connectors configured for this server.
      Throws:
        `Exception`

    - #### getConnectorsAsJSON

          String getConnectorsAsJSON()
                              throws Exception

      Returns the connectors configured for this server using JSON serialization.
      Throws:
        `Exception`

    - #### getAddressNames

          String[] getAddressNames()

      Returns the addresses created on this server.

    - #### getQueueNames

          String[] getQueueNames()

      Returns the names of the queues created on this server.

    - #### getUptime

          String getUptime()

      Returns the uptime of this server.

    - #### getUptimeMillis

          long getUptimeMillis()

      Returns the uptime of this server.

    - #### isReplicaSync

          boolean isReplicaSync()

      Returns whether the initial replication synchronization process with the backup server is complete; applicable for either the live or backup server.

    - #### getDiskScanPeriod

          int getDiskScanPeriod()

      Returns how often the server checks for disk space usage.

    - #### getMaxDiskUsage

          int getMaxDiskUsage()

      Returns the disk use max limit.

    - #### getGlobalMaxSize

          long getGlobalMaxSize()

      Returns the global max bytes limit for in-memory messages.

    - #### createQueue

          void createQueue(String address,
                           String name)
                    throws Exception

      Create a durable queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
      Throws:
        `Exception`

    - #### createQueue

          void createQueue(String address,
                           String name,
                           String filter,
                           boolean durable)
                    throws Exception

      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
        `durable` - whether the queue is durable
      Throws:
        `Exception`

    - #### createQueue

          void createQueue(String address,
                           String name,
                           boolean durable)
                    throws Exception

      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `durable` - whether the queue is durable
      Throws:
        `Exception`

    - #### deployQueue

          void deployQueue(String address,
                           String name,
                           String filter)
                    throws Exception

      Deploy a durable queue.
      If `address` is `null` it will be defaulted to `name`.
      This method will do nothing if the queue with the given name already exists on the server.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
      Throws:
        `Exception`

    - #### deployQueue

          void deployQueue(String address,
                           String name,
                           String filter,
                           boolean durable)
                    throws Exception

      Deploy a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method will do nothing if the queue with the given name already exists on the server.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
        `durable` - whether the queue is durable
      Throws:
        `Exception`

    - #### destroyQueue

          void destroyQueue(String name)
                     throws Exception

      Destroys the queue corresponding to the specified name.
      Throws:
        `Exception`

    - #### destroyQueue

          void destroyQueue(String name,
                            boolean removeConsumers)
                     throws Exception

      Destroys the queue corresponding to the specified name.
      Throws:
        `Exception`

    - #### enableMessageCounters

          void enableMessageCounters()
                              throws Exception

      Enables message counters for this server.
      Throws:
        `Exception`

    - #### disableMessageCounters

          void disableMessageCounters()
                               throws Exception

      Disables message counters for this server.
      Throws:
        `Exception`

    - #### resetAllMessageCounters

          void resetAllMessageCounters()
                                throws Exception

      Reset all message counters.
      Throws:
        `Exception`

    - #### resetAllMessageCounterHistories

          void resetAllMessageCounterHistories()
                                        throws Exception

      Reset histories for all message counters.
      Throws:
        `Exception`

    - #### listPreparedTransactions

          String[] listPreparedTransactions()
                                     throws Exception

      List all the prepared transaction, sorted by date, oldest first.
      The Strings are Base-64 representation of the transaction XID and can be used to heuristically commit or rollback the transactions.
      Throws:
        `Exception`
      See Also:
        `commitPreparedTransaction(String)`, `rollbackPreparedTransaction(String)`

    - #### listPreparedTransactionDetailsAsJSON

          String listPreparedTransactionDetailsAsJSON()
                                               throws Exception

      List all the prepared transaction, sorted by date, oldest first, with details, in text format.
      Throws:
        `Exception`

    - #### listPreparedTransactionDetailsAsHTML

          String listPreparedTransactionDetailsAsHTML()
                                               throws Exception

      List all the prepared transaction, sorted by date, oldest first, with details, in HTML format
      Throws:
        `Exception`

    - #### listHeuristicCommittedTransactions

          String[] listHeuristicCommittedTransactions()
                                               throws Exception

      List transactions which have been heuristically committed.
      Throws:
        `Exception`

    - #### listHeuristicRolledBackTransactions

          String[] listHeuristicRolledBackTransactions()
                                                throws Exception

      List transactions which have been heuristically rolled back.
      Throws:
        `Exception`

    - #### commitPreparedTransaction

          boolean commitPreparedTransaction(String transactionAsBase64)
                                     throws Exception

      Heuristically commits a prepared transaction.
      Parameters:
        `transactionAsBase64` - base 64 representation of a prepare transaction
      Returns:
        `true` if the transaction was successfully committed, `false` else
      Throws:
        `Exception`
      See Also:
        `listPreparedTransactions()`

    - #### rollbackPreparedTransaction

          boolean rollbackPreparedTransaction(String transactionAsBase64)
                                       throws Exception

      Heuristically rolls back a prepared transaction.
      Parameters:
        `transactionAsBase64` - base 64 representation of a prepare transaction
      Returns:
        `true` if the transaction was successfully rolled back, `false` else
      Throws:
        `Exception`
      See Also:
        `listPreparedTransactions()`

    - #### listRemoteAddresses

          String[] listRemoteAddresses()
                                throws Exception

      Lists the addresses of all the clients connected to this address.
      Throws:
        `Exception`

    - #### listRemoteAddresses

          String[] listRemoteAddresses(String ipAddress)
                                throws Exception

      Lists the addresses of the clients connected to this address which matches the specified IP address.
      Throws:
        `Exception`

    - #### closeConnectionsForAddress

          boolean closeConnectionsForAddress(String ipAddress)
                                      throws Exception

      Closes all the connections of clients connected to this server which matches the specified IP address.
      Throws:
        `Exception`

    - #### closeConsumerConnectionsForAddress

          boolean closeConsumerConnectionsForAddress(String address)
                                              throws Exception

      Closes all the connections of clients connected to this server which matches the specified IP address.
      Throws:
        `Exception`

    - #### closeConnectionsForUser

          boolean closeConnectionsForUser(String address)
                                   throws Exception

      Closes all the connections of sessions with a matching user name.
      Throws:
        `Exception`

    - #### listConnectionIDs

          String[] listConnectionIDs()
                              throws Exception

      Lists all the IDs of the connections connected to this server.
      Throws:
        `Exception`

    - #### listProducersInfoAsJSON

          String listProducersInfoAsJSON()
                                  throws Exception

      Throws:
        `Exception`

    - #### listConnectionsAsJSON

          String listConnectionsAsJSON()
                                throws Exception

      Lists all the connections connected to this server. The returned String is a JSON string containing details about each connection, e.g.:

           [
             {
               "creationTime": 1469240429671,
               "sessionCount": 1,
               "implementation": "RemotingConnectionImpl",
               "connectionID": "1648309901",
               "clientAddress": "\/127.0.0.1:57649"
             }
           ]

      Throws:
        `Exception`

    - #### listConsumersAsJSON

          String listConsumersAsJSON(String connectionID)
                              throws Exception

      Lists all the consumers which belongs to the connection specified by the connectionID. The returned String is a JSON string containing details about each consumer, e.g.:

           [
             {
               "filter": "color = 'RED'",
               "queueName": "2ea5b050-28bf-4ee2-9b24-b73f5983192a",
               "creationTime": 1469239602459,
               "deliveringCount": 0,
               "consumerID": 1,
               "browseOnly": true,
               "connectionID": "1963ece3-507a-11e6-94ff-e8b1fc439540",
               "sessionID": "19676f55-507a-11e6-94ff-e8b1fc439540"
             }
           ]

      Throws:
        `Exception`

    - #### listAllConsumersAsJSON

          String listAllConsumersAsJSON()
                                 throws Exception

      Lists all the consumers connected to this server. The returned String is a JSON string containing details about each consumer, e.g.:

           [
             {
               "queueName": "fa87c64c-0a38-4697-8421-72e34d17429d",
               "creationTime": 1469235956168,
               "deliveringCount": 0,
               "consumerID": 0,
               "browseOnly": false,
               "connectionID": "9c0d42e7-5071-11e6-9e29-e8b1fc439540",
               "sessionID": "9c0d9109-5071-11e6-9e29-e8b1fc439540"
             }
           ]

      Throws:
        `Exception`

    - #### listSessionsAsJSON

          String listSessionsAsJSON(String connectionID)
                             throws Exception

      Lists details about all the sessions for the specified connection ID. The returned String is a JSON string containing details about each session associated with the specified ID, e.g.:

           [
             {
               "principal": "myUser",
               "creationTime": 1469240773157,
               "consumerCount": 0,
               "sessionID": "d33d10db-507c-11e6-9e47-e8b1fc439540"
             }
           ]

      Throws:
        `Exception`

    - #### listSessions

          String[] listSessions(String connectionID)
                         throws Exception

      Lists all the sessions IDs for the specified connection ID.
      Throws:
        `Exception`

    - #### sendQueueInfoToQueue

          void sendQueueInfoToQueue(String queueName,
                                    String address)
                             throws Exception

      This method is used by ActiveMQ Artemis clustering and must not be called by ActiveMQ Artemis clients.
      Throws:
        `Exception`

    - #### addSecuritySettings

          void addSecuritySettings(String addressMatch,
                                   String sendRoles,
                                   String consumeRoles,
                                   String createDurableQueueRoles,
                                   String deleteDurableQueueRoles,
                                   String createNonDurableQueueRoles,
                                   String deleteNonDurableQueueRoles,
                                   String manageRoles)
                            throws Exception

      Throws:
        `Exception`

    - #### addSecuritySettings

          void addSecuritySettings(String addressMatch,
                                   String sendRoles,
                                   String consumeRoles,
                                   String createDurableQueueRoles,
                                   String deleteDurableQueueRoles,
                                   String createNonDurableQueueRoles,
                                   String deleteNonDurableQueueRoles,
                                   String manageRoles,
                                   String browseRoles)
                            throws Exception

      Throws:
        `Exception`

    - #### removeSecuritySettings

          void removeSecuritySettings(String addressMatch)
                               throws Exception

      Throws:
        `Exception`

    - #### getRoles

          Object[] getRoles(String addressMatch)
                     throws Exception

      Throws:
        `Exception`

    - #### getRolesAsJSON

          String getRolesAsJSON(String addressMatch)
                         throws Exception

      Throws:
        `Exception`

    - #### addAddressSettings

          void addAddressSettings(String addressMatch,
                                  String DLA,
                                  String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int deliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageMaxCacheSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics)
                           throws Exception

      adds a new address setting for a specific address
      Throws:
        `Exception`

    - #### removeAddressSettings

          void removeAddressSettings(String addressMatch)
                              throws Exception

      Throws:
        `Exception`

    - #### getAddressSettingsAsJSON

          String getAddressSettingsAsJSON(String addressMatch)
                                   throws Exception

      returns the address settings as a JSON string
      Throws:
        `Exception`

    - #### getDivertNames

          String[] getDivertNames()

    - #### createDivert

          void createDivert(String name,
                            String routingName,
                            String address,
                            String forwardingAddress,
                            boolean exclusive,
                            String filterString,
                            String transformerClassName)
                     throws Exception

      Throws:
        `Exception`

    - #### destroyDivert

          void destroyDivert(String name)
                      throws Exception

      Throws:
        `Exception`

    - #### getBridgeNames

          String[] getBridgeNames()

    - #### createBridge

          void createBridge(String name,
                            String queueName,
                            String forwardingAddress,
                            String filterString,
                            String transformerClassName,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            int producerWindowSize,
                            long clientFailureCheckPeriod,
                            String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            String user,
                            String password)
                     throws Exception

      Throws:
        `Exception`

    - #### createBridge

          void createBridge(String name,
                            String queueName,
                            String forwardingAddress,
                            String filterString,
                            String transformerClassName,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            long clientFailureCheckPeriod,
                            String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            String user,
                            String password)
                     throws Exception

      Throws:
        `Exception`

    - #### destroyBridge

          void destroyBridge(String name)
                      throws Exception

      Throws:
        `Exception`

    - #### createConnectorService

          void createConnectorService(String name,
                                      String factoryClass,
                                      Map<String,Object> parameters)
                               throws Exception

      Throws:
        `Exception`

    - #### destroyConnectorService

          void destroyConnectorService(String name)
                                throws Exception

      Throws:
        `Exception`

    - #### getConnectorServices

          String[] getConnectorServices()

    - #### forceFailover

          void forceFailover()
                      throws Exception

      Throws:
        `Exception`

    - #### updateDuplicateIdCache

          void updateDuplicateIdCache(String address,
                                      Object[] ids)
                               throws Exception

      Throws:
        `Exception`

    - #### scaleDown

          void scaleDown(String connector)
                  throws Exception

      Throws:
        `Exception`

Copyright © 2017 The Apache Software Foundation. All rights reserved.